package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.Objects;

/**
 * DnsProxySettingOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class DnsProxySettingOpenApiVo   {
  @JsonProperty("enable")
  private Boolean enable;

  @JsonProperty("type")
  private Integer type;

  @JsonProperty("dnsSecSetting")
  private DnsSecSettingOpenApiVo dnsSecSetting;

  @JsonProperty("dohSetting")
  private DohSettingOpenApiVo dohSetting;

  @JsonProperty("dotSetting")
  private DotSettingOpenApiVo dotSetting;

  public DnsProxySettingOpenApiVo enable(Boolean enable) {
    this.enable = enable;
    return this;
  }

  /**
   * DNS proxy setting enable status
   * @return enable
  */
  @ApiModelProperty(required = true, value = "DNS proxy setting enable status")
  @NotNull


  public Boolean getEnable() {
    return enable;
  }

  public void setEnable(Boolean enable) {
    this.enable = enable;
  }

  public DnsProxySettingOpenApiVo type(Integer type) {
    this.type = type;
    return this;
  }

  /**
   * DNS proxy setting type. Type should be a value as follows: 0: DNSSEC, 1: DoH, 2: DoT
   * @return type
  */
  @ApiModelProperty(value = "DNS proxy setting type. Type should be a value as follows: 0: DNSSEC, 1: DoH, 2: DoT")


  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public DnsProxySettingOpenApiVo dnsSecSetting(DnsSecSettingOpenApiVo dnsSecSetting) {
    this.dnsSecSetting = dnsSecSetting;
    return this;
  }

  /**
   * Get dnsSecSetting
   * @return dnsSecSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public DnsSecSettingOpenApiVo getDnsSecSetting() {
    return dnsSecSetting;
  }

  public void setDnsSecSetting(DnsSecSettingOpenApiVo dnsSecSetting) {
    this.dnsSecSetting = dnsSecSetting;
  }

  public DnsProxySettingOpenApiVo dohSetting(DohSettingOpenApiVo dohSetting) {
    this.dohSetting = dohSetting;
    return this;
  }

  /**
   * Get dohSetting
   * @return dohSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public DohSettingOpenApiVo getDohSetting() {
    return dohSetting;
  }

  public void setDohSetting(DohSettingOpenApiVo dohSetting) {
    this.dohSetting = dohSetting;
  }

  public DnsProxySettingOpenApiVo dotSetting(DotSettingOpenApiVo dotSetting) {
    this.dotSetting = dotSetting;
    return this;
  }

  /**
   * Get dotSetting
   * @return dotSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public DotSettingOpenApiVo getDotSetting() {
    return dotSetting;
  }

  public void setDotSetting(DotSettingOpenApiVo dotSetting) {
    this.dotSetting = dotSetting;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DnsProxySettingOpenApiVo dnsProxySettingOpenApiVo = (DnsProxySettingOpenApiVo) o;
    return Objects.equals(this.enable, dnsProxySettingOpenApiVo.enable) &&
        Objects.equals(this.type, dnsProxySettingOpenApiVo.type) &&
        Objects.equals(this.dnsSecSetting, dnsProxySettingOpenApiVo.dnsSecSetting) &&
        Objects.equals(this.dohSetting, dnsProxySettingOpenApiVo.dohSetting) &&
        Objects.equals(this.dotSetting, dnsProxySettingOpenApiVo.dotSetting);
  }

  @Override
  public int hashCode() {
    return Objects.hash(enable, type, dnsSecSetting, dohSetting, dotSetting);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DnsProxySettingOpenApiVo {\n");
    
    sb.append("    enable: ").append(toIndentedString(enable)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    dnsSecSetting: ").append(toIndentedString(dnsSecSetting)).append("\n");
    sb.append("    dohSetting: ").append(toIndentedString(dohSetting)).append("\n");
    sb.append("    dotSetting: ").append(toIndentedString(dotSetting)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

